#include <stdio.h>

#define EM 0
#define BK -1
#define BQ -2
#define BR -3
#define BB -4
#define BN -5
#define BP -6
#define WK 1
#define WQ 2
#define WR 3
#define WB 4
#define WN 5
#define WP 6

#define NSYM 26
char a[NSYM] = {
'0', '1', '2', '3', '4', '5', '6', '7', '8',
'k', 'q', 'r', 'b', 'n', 'p', 's', 'o',
'K', 'Q', 'R', 'B', 'N', 'P', 'S', 'O'};
int c[NSYM] = {
 0,  1,  2,  3,  4,  5,  6,  7,  8,
BK, BQ, BR, BB, BN, BP, BR, BP,
WK, WQ, WR, WB, WN, WP, WR, WP, ' '};
char p[7] = {' ', 'K','Q','R','B','N', ' '};

#ifndef LINE_MAX
#define LINE_MAX 1024
#endif

int main(void);
int main(void)
{
	long nline;
	char line[LINE_MAX];
	char colour[LINE_MAX];
	char move[LINE_MAX];
	int b[64];

	printf("\\documentstyle[twocolumn,chess,a4]{article}\n");
	printf("\\begin{document}\n");
	nline = 0;
	while(1)
	{
		int i, j, k, l;

		i = 0;
		l = 0;
		while (l < 8)
		{
			if (scanf("%1s", line) != 1) goto final;
			for (j = 0; (j < NSYM) && (*line != a[j]); j++);
			if (j < 9)
				for (k = 0; k < j; k++) b[i++] = EM;
			else if (j < NSYM)
				b[i++] = c[j];
			else if (*line == '/')
				l++;
			else
				{printf("line=%ld unknown char: %s\n", nline, line); exit(1);}
		}
		nline++;
		if (i != 64)
			{printf("line=%ld i != 64\n", nline); exit(1);}
		if (scanf("%1s", colour) != 1)
			{printf("line=%ld colour not found", nline); exit(1);}
		if (scanf("%s", move) != 1)
			{printf("line=%ld move not found", nline); exit(1);}
		gets(line);
		printf("\\begin{position}\n");
		for (k = 1; k > -3; k-=2)
		{
			int n, m;

			if (k == 1) 
				printf("\\White(");
			else 
				printf("\\Black(");
			/* count pieces */
			n = 0;
			for (i = 0; i < 64; i++)
				if ((k*b[i]) > 0) n++;
			m = 0;
			for (j = 1; j < 7; j++)
			{
				for (i = 0; i < 64; i++)
				{
					if (b[i] == (k*j))
					{
						m++;
						printf("%c%c%c", p[j], 'a' + i % 8, '1' + (7 - i / 8));	
						if (m < n) printf(",");
					}
				}
			}
			if (n != m)
				{printf("line=%ld n=%d m=%d\n", nline, n, m); exit(1);}
			printf(")\n");
		}
		/*
		if (*colour == 'w')
			printf("\\global\\Whitetrue\n");
		else
			printf("\\global\\Whitefalse\n");
		printf("\\global\\movecount=0 ");
		*/
		printf("\\end{position}\n");
		printf("\\showboard\n");
		if (move[3] == 'x')
			printf("\\ply %c%c%c%c\n", move[1], move[2], move[5], move[6]);
		else
			printf("\\ply %c%c%c%c\n", move[1], move[2], move[3], move[4]);
		printf("\\vfill");
	}
	final:
	printf("\\end{document}\n");
	exit(0);
}
